<template>
  <div>
    <v-toolbar
      flat
      height="100px"
    >
      <v-toolbar-title>
        <a
          href="/"
          class="d-flex align-center"
        >
          <v-img
            class="logo"
            :src="imageLink + 'logo.svg'"
            alt="Picholines"
            height="80"
            width="180"
            contain
            eager
          />
        </a>
      </v-toolbar-title>
      <p 
        class="font-weight-bold ml-3 mt-12 pt-1 text-md-body-2 text-sm-caption"
        v-html="$t('buttons.laureat.label')" 
      />

      <v-spacer />
      
      <div
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.dynamicLines.route')"
          class="font-weight-bold"
        >
          {{ $t('buttons.dynamicLines.label') }}
        </v-btn>
      </div>
      <div
        v-if="user"
        class="hidden-md-and-down"
      >
        <MMessageBtn
          :unread-message-number="unreadMessageNumber"
          :text-color-class="'font-weight-bold text-capitalize'"
        />
        <MHeaderCommunities
          :user-id="user.id"
          :text-color-class="'font-weight-bold text-capitalize'"
          :links-color-class="'black--text'"
        />
        <MHeaderProfile
          :avatar="user.avatars[0]"
          :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
          :text-color-class="'font-weight-bold text-capitalize'"
          :links-color-class="'black--text'"
        />
      </div>
      <div
        v-else
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.signup.route')"
          class="font-weight-bold"
        >
          {{ $t('buttons.signup.label') }}
        </v-btn>
        <v-btn
          rounded
          text
          :href="$t('buttons.logIn.route')"
          class="font-weight-bold"
        >
          {{ $t('buttons.logIn.label') }}
        </v-btn>
      </div>
      <div
        class="hidden-md-and-down"
      >
        <v-btn
          rounded
          text
          :href="$t('buttons.infos.route')"
          class="font-weight-bold"
        >
          {{ $t('buttons.infos.label') }}
        </v-btn>
      </div>
      <v-btn
        rounded
        :disabled="!user"
        :href="$t('buttons.shareAnAd.route')"
        class="font-weight-medium hidden-md-and-down"
        color="success"
      >
        {{ $t('buttons.shareAnAd.label') }}
      </v-btn>
      <div
        class="hidden-md-and-down"
      >
        <MHeaderLanguage
          :languages="languages"
          :language="dlocale"
          @languageSelected="updateLanguage"
        />
      </div>

      <!--Display menu when user is connected-->
      <v-menu
        v-if="user"
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            class="hidden-lg-and-up"
            v-on="on"
          >
            <v-icon color="primary">
              mdi-menu
            </v-icon>
          </v-btn>
        </template>
        <v-list>
          <v-list-item>
            <v-list-item-title>
              <MHeaderLanguage
                text-class="white--text font-weight-bold"
                :languages="languages"
                :language="dlocale"
                @languageSelected="updateLanguage"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderProfile
                :avatar="user.avatars[0]"
                :short-family-name="(user.shortFamilyName) ? user.givenName+' '+user.shortFamilyName : '-'"
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <MHeaderCommunities
                :user-id="user.id"                  
              />
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.dynamicLines.route')"
              >
                {{ $t('buttons.dynamicLines.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :href="$t('buttons.messages.route')"
              >
                {{ $t('buttons.messages.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.infos.route')"
              >
                {{ $t('buttons.infos.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>

      <!--Display menu when there is no connected user-->
      <v-menu
        v-else
        bottom
        left
        z-index="9"
      >
        <template v-slot:activator="{ on }">
          <v-btn
            class="hidden-lg-and-up"
            v-on="on"
          >
            <v-icon color="primary">
              mdi-menu
            </v-icon>
          </v-btn>
        </template>

        <v-list>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.dynamicLines.route')"
              >
                {{ $t('buttons.dynamicLines.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.signup.route')"
              >
                {{ $t('buttons.signup.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.logIn.route')"
              >
                {{ $t('buttons.logIn.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                rounded
                text
                :href="$t('buttons.infos.route')"
              >
                {{ $t('buttons.infos.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
          <v-list-item>
            <v-list-item-title>
              <v-btn
                text
                rounded
                :disabled="!user"
                :href="$t('buttons.shareAnAd.route')"
              >
                {{ $t('buttons.shareAnAd.label') }}
              </v-btn>
            </v-list-item-title>
          </v-list-item>
        </v-list>
      </v-menu>
    </v-toolbar>
    <GamificationNotifications :user-gamification-notifications="(user && user.gamificationNotifications) ? user.gamificationNotifications : null" />
    <GratuityNotifications :user-gratuity-notifications="(user && user.gratuityNotifications) ? user.gratuityNotifications : null" />
    <!-- legal guardian dialog -->
    <v-dialog
      v-if="user"
      v-model="activeLegalGuardianDialog"
      persistent
      max-width="900"
    >
      <v-card>
        <v-card-title
          class="text-h5 justify-center"
        >
          {{ $t('dialog.parentalConsent.title') }}
        </v-card-title>
        <v-card-text v-html="$t('dialog.parentalConsent.content',{'legalGuardianEmail':user.legalGuardianEmail})" />
        <v-card-actions>
          <v-spacer />
          <v-btn
            color="secondary"
            primary
            rounded
            :href="this.$t('buttons.logOut.route')"
          >
            {{ $t('dialog.parentalConsent.buttonLabel') }}
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import { merge, has } from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/base/MHeader/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/base/MHeader/";
import MHeaderProfile from "@components/base/MHeaderProfile.vue";
import MHeaderCommunities from "@components/base/MHeaderCommunities.vue";
import MHeaderLanguage from "@components/base/MHeaderLanguage.vue";
import MMessageBtn from "@components/base/MMessageBtn.vue";
import GamificationNotifications from "@components/utilities/gamification/GamificationNotifications";
import GratuityNotifications from "@components/utilities/gratuity/GratuityNotifications";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    MHeaderProfile,
    MHeaderCommunities,
    MHeaderLanguage,
    MMessageBtn,
    GamificationNotifications,
    GratuityNotifications
  },
  props: {
    user: {
      type: Object,
      default: null
    },
    locale: {
      type: String,
      default: "fr"
    },
    languages: {
      type: Object,
      default: () => {}
    },
    token: {
      type: String,
      default: ''
    },
    gamificationActive:{
      type: Boolean,
      default: false
    }
  },
  data () {
    return {
      imageLink: "/images/pages/header/",
      width: 0,
      snackbar: null,
      defaultLocale: 'fr',
      dlocale: this.locale,
      activeLegalGuardianDialog: false
    }
  },
  computed:{
    unreadMessageNumber(){
      return this.user.unreadCarpoolMessageNumber + this.user.unreadDirectMessageNumber + this.user.unreadSolidaryMessageNumber; 
    }
  },
  mounted() {
    if (has(this.languages, this.locale)) {
      this.dlocale = this.locale;
    } else {
      this.dlocale = this.defaultLocale;
    }
    this.$store.commit('g/setActive',this.gamificationActive);
    this.$store.commit('grt/setActive',this.gratuityActive);
  },
  created() {
    this.$store.commit('a/setToken',this.user?.token ? this.user.token : this.token);
    if(this.user){
      localStorage.setItem('X-LOCALE',this.dlocale);
    }
    if(this.user?.needParentalConsent) {
      this.activeLegalGuardianDialog = true;
    }
    this.$root.$i18n.locale = this.dlocale
  },
  methods:{
    updateLanguage(language) {
      this.$root.$i18n.locale = language
    },
  }
};
</script>
<style lang="scss" scoped>
*{
  text-transform: initial;
}
</style>
